const { fs } = require('./../bootstrap/modules');

function createMiddleware(middlewareName, command) {
    let appName = command.options.app || APP_NAME;

    let middlewarePath = ROOT + `/src/${appName}/components/middleware/${middlewareName}.js`;

    if (fs.exists(middlewarePath)) {
        die(`${cli.redBright(middlewareName)} middleware already exists!`);
    }

    echo(`${cli.yellow('Creating')} ${cli.green(middlewareName)} middleware...`);

    // first we will copy the middleware
    fs.copy(FRAMEWORK_RESOURCES_PATH + '/middleware.js', middlewarePath);

    let middlewareFileContent = fs.get(middlewarePath);

    let middlewareClass = middlewareName.toStudlyCase() + 'Middleware';

    middlewareFileContent = middlewareFileContent.replaceAll('MiddlewareClass', middlewareClass)
                                                .replaceAll('middlewareName', middlewareName);

    fs.put(middlewarePath, middlewareFileContent);

    echo(`${cli.cyan(middlewareName)} ${cli.green('middleware has been created successfully.')}`);
}

module.exports = function (command) {
    for (let middlewareName of command.middlewares) {
        createMiddleware(middlewareName, command);
    }

    die();
}